<template>
  <div>
    <h1
      class="fr-col-12 fr-display-xs fr-mb-6w fr-text-title--blue-france anct-text-center"
    >
      Investigations
    </h1>

    <p class="fr-text--lg">
      Une <strong>Investigation</strong> est une méthode où un ou plusieurs
      agents territoriaux explore(nt) une problématique récurrente sur le
      terrain. L’objectif est de concevoir une première solution et de la tester
      au contact du public qu’elle cible. Sur une période de 9 à 12 semaines,
      l’équipe d’agents publics territoriaux est accompagnée par un coach et un
      designer. L’accompagnement est entièrement financé par l’ANCT.
    </p>

    <nuxt-link
      :to="{ name: 'relance-investigations' }"
      tag="button"
      class="fr-btn fr-text--md fr-grid-row fr-grid-row--middle fr-mb-2w anct-border-rounded"
    >
      <span class="fr-col fr-mr-2w"
        ><strong>Découvrir le programme national d'investigations</strong></span
      >
      <span class="fr-icon-arrow-right-line" aria-hidden="true"></span>
    </nuxt-link>

    <section>
      <div class="fr-select-group fr-mt-2w fr-mb-6w">
        <label class="fr-label" for="select">
          <strong>Sélectionner le type d'investigation :</strong>
        </label>
        <select
          id="select"
          class="fr-select"
          name="select"
          @change="fetchInvestigations"
        >
          <option value="" selected disabled hidden>
            Selectionnez une option
          </option>
          <option value="">Toutes les investigations</option>
          <option
            v-for="(option, index) in selectOptions"
            :key="`investigation-select-option${index}`"
            :value="option"
          >
            {{ option }}
          </option>
        </select>
      </div>

      <div
        v-for="(investigation, index) in investigations"
        :key="`investigation--${index}`"
        class="fr-card fr-card--horizontal fr-enlarge-link fr-my-2w"
      >
        <div class="fr-card__body">
          <h4 class="fr-card__title">
            <nuxt-link
              :to="investigation.to"
              class="fr-card__link fr-text-title--blue-france"
              >{{ investigation.title
              }}<em v-if="investigation.entity" class="fr-ml-1w"
                >-- {{ investigation.entity }}</em
              ></nuxt-link
            >
          </h4>
          <p v-if="investigation.description" class="fr-card__desc">
            {{ investigation.description }}
          </p>
          <p class="fr-card__detail">{{ investigation.status }}</p>
        </div>
      </div>
    </section>
  </div>
</template>

<script>
export default {
  name: 'InvestigationsPage',

  async asyncData({ $axios }) {
    const { data } = await $axios.$get('/items/investigations', {
      params: {
        filter: { status: { _neq: 'draft' } },
        fields:
          'id,nom,mission,status,promotion.nom,communes.communes_id.nom,epcis.epcis_id.nom,departements.departements_id.nom,regions.regions_id.nom',
      },
    });

    const investigations = data.map(
      ({
        id,
        nom,
        mission,
        status,
        communes,
        departements,
        regions,
        epcis,
      }) => {
        const formattedStatus = status.split('_').join(' ').toUpperCase();
        const title = nom || mission;
        const description = title !== mission && mission;
        const entity =
          communes[0]?.communes_id.nom ||
          epcis[0]?.epcis_id.nom ||
          departements[0]?.departements_id.nom ||
          regions[0]?.regions_id.nom;

        return {
          title,
          description,
          status: formattedStatus,
          entity,
          to: { name: 'investigations-id', params: { id } },
        };
      },
    );

    const selectOptions = data
      .reduce((options, { promotion }) => {
        if (promotion && !options.includes(promotion.nom)) {
          return [...options, promotion.nom];
        }

        return options;
      }, [])
      .sort();

    return {
      filter: '',
      investigations,
      selectOptions,
    };
  },

  data() {
    return {
      investigations: [],
      selectOptions: [],
      data: undefined,
    };
  },

  methods: {
    async fetchInvestigations({ target }) {
      const filter = {
        status: { _neq: 'draft' },
        promotion: { nom: { _eq: target.value } },
      };
      if (!target.value) {
        delete filter.promotion;
      }

      const { data } = await this.$axios.$get('/items/investigations', {
        params: {
          filter,
          fields:
            'id,nom,mission,status,promotion.nom,communes.communes_id.nom,epcis.epcis_id.nom,departements.departements_id.nom,regions.regions_id.nom',
        },
      });

      this.investigations = data.map(
        ({
          id,
          nom,
          mission,
          status,
          communes,
          departements,
          regions,
          epcis,
        }) => {
          const formattedStatus = status.split('_').join(' ').toUpperCase();
          const title = nom || mission;
          const description = title !== mission && mission;
          const entity =
            communes[0]?.communes_id.nom ||
            epcis[0]?.epcis_id.nom ||
            departements[0]?.departements_id.nom ||
            regions[0]?.regions_id.nom;

          return {
            title,
            description,
            status: formattedStatus,
            entity,
            to: { name: 'investigations-id', params: { id } },
          };
        },
      );
    },
  },
};
</script>

<style scoped></style>
